<?php
/**
 * Get, validate, and validate SERVER_SOFTWARE variable.
 *
 * @since 10.4.8
 *
 * @category   WordPress\Plugin
 * @package    Connections Business Directory
 * @subpackage Connections\Request\Server SERVER_SOFTWARE
 * @author     Steven A. Zahm
 * @license    GPL-2.0+
 * @copyright  Copyright (c) 2021, Steven A. Zahm
 * @link       https://connections-pro.com/
 */

namespace Connections_Directory\Request;

/**
 * Class Server_Software
 *
 * @package Connections_Directory\Request
 */
class Server_Software extends Server {

	/**
	 * The request variable key.
	 *
	 * @since 10.4.8
	 *
	 * @var string
	 */
	protected $key = 'SERVER_SOFTWARE';
}
